//+------------------------------------------------------------------+
//|                                                       RSICD.mq4  |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2008, seifer."

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  PaleGreen
#property  indicator_color2  Red
#property  indicator_width1  2
//---- indicator parameters
extern int FastRSI=10;
extern int SlowRSI=20;
extern int SignalRSI=0;
//---- indicator buffers
double     RSIBuffer[];
double     SignalBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,SignalRSI);
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,RSIBuffer);
   SetIndexBuffer(1,SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("RSICD("+FastRSI+","+SlowRSI+","+SignalRSI+")");
   SetIndexLabel(0,"RSI");
   SetIndexLabel(1,"Signal");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|  RSI Convergence/Divergence                                      |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- cci counted in the 1-st buffer
   for(int i=0; i<limit; i++)
      RSIBuffer[i]=iRSI(NULL,0,SlowRSI,PRICE_TYPICAL,i)-iRSI(NULL,0,FastRSI,PRICE_TYPICAL,i);
//---- signal line counted in the 2-nd buffer
   for(i=0; i<limit; i++)
      SignalBuffer[i]=iRSIOnArray(RSIBuffer,Bars,SignalRSI,i);
//---- done
   return(0);
  }
  

